﻿using System;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace GridViewFilterIssue
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radGridView1.Anchor = AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Top;
            //radGridView1.ValueChanged += RadGridView1_ValueChanged;
            radGridView1.DataSource = new BindingList<TestObj>()
            {
                new TestObj("10510337", "D", "Alfred RT1000 Alto sax"),
                new TestObj("10510337", "I", "Alfred RT1000 Alto sax"),
                new TestObj("911", "D", "Bass Amp"),
                new TestObj("911", "I", "Bass Amp"),
                new TestObj("BDOWN", "D", "Anthem Guitars BDOWN Alto sax Alto sax"),
                new TestObj("BDOWN", "I", "Anthem Guitars BDOWN Alto sax Alto sax"),
                new TestObj("GUN", "D", "Smith & Wesson GUN .45"),
                new TestObj("GUN", "I", "Smith & Wesson GUN .45"),
                new TestObj("KB400N", "D", "Music Stand"),
                new TestObj("KB400N", "I", "Music Stand"),
                new TestObj("LUB", "D", "Alfred LUB Lubricants"),
                new TestObj("LUB", "I", "Alfred LUB Lubricants"),
                new TestObj("LUBEB", "D", "Alfred LUBEB Lubricants"),
                new TestObj("LUBEB", "I", "Alfred LUBEB Lubricants"),
                new TestObj("MEAH", "D", "AlfredMEAHKitsBand & Orch AccKitsMEAH{{17}}"),
                new TestObj("MEAH", "I", "AlfredMEAHKitsBand & Orch AccKitsMEAH{{17}}"),
                new TestObj("MEAH1", "D", "AlfredMEAH1KitsBand & Orch AccKitsMEAH1{{17}}"),
                new TestObj("MEAH1", "I", "AlfredMEAH1KitsBand & Orch AccKitsMEAH1{{17}}"),
                new TestObj("RT20", "D", "Anthem Guitars RT20 Band Accessory Band Accessory"),
                new TestObj("RT20", "I", "Anthem Guitars RT20 Band Accessory Band Accessory"),
                new TestObj("RT24", "D", "Alfred RT24 Alto sax Alto sax"),
                new TestObj("RT24", "I", "Alfred RT24 Alto sax Alto sax"),
                new TestObj("RT34", "D", "Alfred RT34 Alto sax Alto sax"),
                new TestObj("RT34", "I", "Alfred RT34 Alto sax Alto sax"),
                new TestObj("SRVCPART", "D", "1 SRVCPART Alto sax Alto sax"),
                new TestObj("SRVCPART", "I", "1 SRVCPART Alto sax Alto sax"),
                new TestObj("TESTME", "D", "General Accessory"),
                new TestObj("TESTME", "I", "General Accessory")
            }.OrderBy(o => o.Sku);

            GridViewCheckBoxColumn checkBoxCol = this.radGridView1.Columns[0] as GridViewCheckBoxColumn;
            checkBoxCol.EditMode = EditMode.OnValueChange;

            this.radGridView1.FilterChanging += RadGridView1_FilterChanging;
            this.radGridView1.FilterChanged += RadGridView1_FilterChanged;
        }

        string propertyName = string.Empty;
        Timer t;
        private void RadGridView1_FilterChanged(object sender, GridViewCollectionChangedEventArgs e)
        {
            if (e.Action == Telerik.WinControls.Data.NotifyCollectionChangedAction.Remove)
            {
                this.radGridView1.SortDescriptors.Add(propertyName, ListSortDirection.Ascending);
                t = new Timer();
                t.Interval = 100;
                t.Tick += T_Tick;
                t.Start(); 
            }
        
        }

        private void T_Tick(object sender, EventArgs e)
        {
            t.Stop();
            this.radGridView1.SortDescriptors.Remove(propertyName);
        }

        private void RadGridView1_FilterChanging(object sender, GridViewCollectionChangingEventArgs e)
        {
            if (e.Action == Telerik.WinControls.Data.NotifyCollectionChangedAction.Remove)
            {
                propertyName = e.PropertyName;
            }
        }

      
       

        private void RadGridView1_ValueChanged(object sender, EventArgs e)
        {
            //if (sender is RadCheckBoxEditor)
            //{
            //    radGridView1.CurrentCell.Value = radGridView1.ActiveEditor.Value;
            //    radGridView1.EndEdit();
            //}
        }
    }

    public class TestObj : System.ComponentModel.INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        private bool _flag;
        private string _sku;
        private string _stloc;
        private string _descr;
        public bool Flag {
            get
            {
                return this._flag;
            }
            set
            {
                this._flag = value;
                OnPropertyChanged("Flag");
            }
        }
        public string Sku {
            get
            {
                return this._sku;
            }
            set
            {
                this._sku = value;
                OnPropertyChanged("Sku");
            }
        }
        public string Stloc {
            get
            {
                return this._stloc;
            }
            set
            {
                this._stloc = value;
                OnPropertyChanged("Stloc");
            }
        }
        public string Desc {
            get
            {
                return this._descr;
            }
            set
            {
                this._descr = value;
                OnPropertyChanged("Desc");
            }
        }

        public TestObj(string sku, string stloc, string desc)
        {
            Flag = false;
            Sku = sku;
            Stloc = stloc;
            Desc = desc;
        }
    }
}
